<?php

/*
Plugin Name: Site Slideshow 
Plugin URI: http://internetdienste-berlin.de
Author: Dietrich Koch 
Author URI: http://internetdienste-berlin.de
Description: Site Slideshow as a sidebar widget represents for any article or page one image of the standard gallery, but it is not repeated any image when it is used by different posts and we show only the first image of every post. Klicking on the center of the slide leads to the article/page the image stems from. There are some options for adapting the slideshow for your purposes. Further information look at http://www.internetdienste-berlin.de/2011/01/artikel-und-seiten-ubergreifende-slideshow-gallery-als-plugin/
Version: 0.9.7
*/

define('DS', DIRECTORY_SEPARATOR);
require_once(dirname(__FILE__) . DS . 'slideshow-gallery-plugin.php');
require_once(dirname(__FILE__) . DS . 'slideshow-gallery-generate.php');
require_once(dirname(__FILE__) . DS . 'slideshow-widget.php');

class Gallery extends GalleryPlugin {
	function Gallery() {
		$url = explode("&", $_SERVER['REQUEST_URI']);
		$this -> url = $url[0];
		$this -> referer = (empty($_SERVER['HTTP_REFERER'])) ? $this -> url : $_SERVER['HTTP_REFERER'];
		
		$this -> register_plugin('site-slideshow', __FILE__);
		
		//WordPress action hooks
		$this -> add_action('admin_menu');
		$this -> add_action('admin_head');

	}

	function admin_menu() {
/*		add_options_page('Site Slideshow Page','Side Slideshow Settings',10,__FILE__,'admin_head_gallery_settings'); erste Schritte
um die Optionen in die Optionpage einzubringen, liefert noch leeres Ergebnis*/
		add_menu_page(__('Slideshow', $this -> plugin_name), __('Slideshow', $this -> plugin_name), 10, "gallery-settings", array($this, 'admin_settings'), $this -> url() . '/images/icon.png');
		$this -> menus['gallery-settings'] = add_submenu_page("gallery", __('Slideshow', $this -> plugin_name), __('Slideshow', $this -> plugin_name), 10, "gallery-settings", array($this, 'admin_settings'));
		
		add_action('admin_head-' . $this -> menus['gallery-settings'], array($this, 'admin_head_gallery_settings'));
	}
	
	function admin_head() {
		$this -> render('head', false, true, 'admin');
	}
	
	function admin_head_gallery_settings() {		
		add_meta_box('submitdiv', __('Save Settings', $this -> plugin_name), array($this -> Metabox, "settings_submit"), $this -> menus['gallery-settings'], 'side', 'core');
		add_meta_box('generaldiv', __('General Settings', $this -> plugin_name), array($this -> Metabox, "settings_general"), $this -> menus['gallery-settings'], 'normal', 'core');
//		add_meta_box('linksimagesdiv', __('Links &amp; Images Overlay', $this -> plugin_name), array($this -> Metabox, "settings_linksimages"), $this -> menus['gallery-settings'], 'normal', 'core');
		add_meta_box('stylesdiv', __('Appearance &amp; Styles', $this -> plugin_name), array($this -> Metabox, "settings_styles"), $this -> menus['gallery-settings'], 'normal', 'core');
		
		do_action('do_meta_boxes', $this -> menus['gallery-settings'], 'normal');
		do_action('do_meta_boxes', $this -> menus['gallery-settings'], 'side');
	}
	
		
	function slideshow($output = true, $post_id = null, $exclude = null) {		
		global $wpdb;	
			$slides = $this -> Slide -> find_all(null, null, array('order', "ASC"));
			$content = $this -> render('gallery', array('slides' => $slides, 'frompost' => false), false, 'default');		
		if ($output) { echo $content; } else { return $content; }
	}
	
	
		
	function admin_settings() {
		switch ($_GET['method']) {
			case 'reset'			:
				global $wpdb;
				$query = "DELETE FROM `" . $wpdb -> prefix . "options` WHERE `option_name` LIKE '" . $this -> pre . "%';";
				
				if ($wpdb -> query($query)) {
					$message = __('All configuration settings have been reset to their defaults', $this -> plugin_name);
					$msg_type = 'message';
					$this -> render_msg($message);	
				} else {
					$message = __('Configuration settings could not be reset', $this -> plugin_name);
					$msg_type = 'error';
					$this -> render_err($message);
				}
				
				$this -> redirect($this -> url, $msg_type, $message);
				break;
			default					:
				if (!empty($_POST)) {
					foreach ($_POST as $pkey => $pval) {					
						$this -> update_option($pkey, $pval);
					}
					
					$message = __('Configuration has been saved', $this -> plugin_name);
					$this -> render_msg($message);
				}	
				break;
		}
				
		$this -> render('settings', false, true, 'admin');
	}
}

//initialize a Gallery object
$Gallery = new Gallery();

?>